#include <math.h>

#include "tk.h"
#include "aux.h"

/*  Render wire frame or solid sphere.  If no display list with
 *  the current model size exists, create a new display list.
 */
void auxWireSphere(GLdouble radius)
{
	tkWireSphere(0, radius);
}

void auxSolidSphere(GLdouble radius)
{
	tkSolidSphere(0, radius);
}

/*  Render wire frame or solid cube.  If no display list with
 *  the current model size exists, create a new display list.
 */
void auxWireCube(GLdouble size)
{
	tkWireCube(0, size);
}

void auxSolidCube(GLdouble size)
{
	tkSolidCube(0, size);
}

/*  Render wire frame or solid cube.  If no display list with
 *  the current model size exists, create a new display list.
 */
void auxWireBox(GLdouble width, GLdouble height, GLdouble depth)
{
	tkWireBox(0, width, height, depth);
}

void auxSolidBox(GLdouble width, GLdouble height, GLdouble depth)
{
	tkSolidBox(0, width, height, depth);
}

/*  Render wire frame or solid tori.  If no display list with
 *  the current model size exists, create a new display list.
 */
void auxWireTorus(GLdouble innerRadius, GLdouble outerRadius)
{
	tkWireTorus(0, innerRadius, outerRadius);
}

void auxSolidTorus(GLdouble innerRadius, GLdouble outerRadius)
{
	tkSolidTorus(0, innerRadius, outerRadius);
}

/*  Render wire frame or solid cylinders.  If no display list with
 *  the current model size exists, create a new display list.
 */
void auxWireCylinder(GLdouble radius, GLdouble height)
{
	tkWireCylinder(0, radius, height);
}

void auxSolidCylinder(GLdouble radius, GLdouble height)
{
	tkSolidCylinder(0, radius, height);
}

/*  Render wire frame or solid icosahedra.  If no display list with
 *  the current model size exists, create a new display list.
 */
void auxWireIcosahedron(GLdouble radius)
{
	tkWireIcosahedron(0, radius);
}

void auxSolidIcosahedron(GLdouble radius)
{
	tkSolidIcosahedron(0, radius);
}

/*  Render wire frame or solid octahedra.  If no display list with
 *  the current model size exists, create a new display list.
 */
void auxWireOctahedron(GLdouble radius)
{
	tkWireOctahedron(0, radius);
}

void auxSolidOctahedron(GLdouble radius)
{
	tkSolidOctahedron(0, radius);
}

/*  Render wire frame or solid tetrahedra.  If no display list with
 *  the current model size exists, create a new display list.
 */
void auxWireTetrahedron(GLdouble radius)
{
	tkWireTetrahedron(0, radius);
}

void auxSolidTetrahedron(GLdouble radius)
{
	tkSolidTetrahedron(0, radius);
}

/*  Render wire frame or solid dodecahedra.  If no display list with
 *  the current model size exists, create a new display list.
 */
void auxWireDodecahedron(GLdouble radius)
{
	tkWireDodecahedron(0, radius);
}

void auxSolidDodecahedron(GLdouble radius)
{
	tkSolidDodecahedron(0, radius);
}

/*  Render wire frame or solid cones.  If no display list with
 *  the current model size exists, create a new display list.
 */
void auxWireCone(GLdouble base, GLdouble height)
{
	tkWireCone(0, base, height);
}

void auxSolidCone(GLdouble base, GLdouble height)
{
	tkSolidCone(0, base, height);
}