
/* Copyright (c) Mark J. Kilgard, 1994. */

/* This program is freely distributable without licensing fees
   and is provided without guarantee or warrantee expressed or
   implied. This program is -not- in the public domain. */

#include <string.h>

#include "glut.h"
#include "glutint.h"

int glutExtensionSupported(const char *extension)
{
	static const GLubyte *extensions = NULL;
	const GLubyte *start;
	GLubyte *where, *terminator;

	/* Extension names should not have spaces. */
	where = (GLubyte *) strchr(extension, ' ');
	if(where || *extension == '\0')
	return 0;

	if(!extensions) extensions = glGetString(GL_EXTENSIONS);
	
	start = extensions;
	for(;;)
	{
		where = (GLubyte *) strstr((const char *)start, extension);
		if(!where) break;
		
		terminator = where + strlen(extension);
		
		if(where == start || *(where - 1) == ' ')
		{
			if(*terminator == ' ' || *terminator == '\0') return 1;
		}
		
		start = terminator;
	}
	
	return 0;
}

int __glutIsSupportedByAGL(const char *extension)
{
	return 0;
}

